// You can import API functions like this from D3.js.
import { select } from 'd3';

import {
  to_json_obj, 
  to_str, 
  print_info, 
  get_current_timestamp
} from './lib';

import { title, subtitle, developer } from './constants';

// Import JSON object `cars`
import { cars } from './carsJSON';


// Set canvas title
select('#title_header').text(
  `${title} @${developer} ${get_current_timestamp()}` 
);
// Set header content
select('h2').text(subtitle);


// Convert JSON object into string
const cars_str = JSON.stringify(cars);

let output_str = '';
// let car_list = [];
// Loop `cars` list
if (cars.length > 0) {
  
	cars.forEach(car => {
  	output_str += print_info(car);
    // car_list.push(car);
  });
  
  /////////////////
  //// CONTENT ////
  /////////////////
  // Set content of 'content' dom element
  // select('#content_list').text(output_str);
  select('#content_list')
    	.selectAll('li')
      .data(cars)
      .enter()
      .append('li')
      .text(car => car.make)
  		;
	
  /////////////////
  //// MESSAGE ////
  /////////////////
  // Selecting on all 'li' element
  const bullet = select('#list_container')
      .selectAll('li')
      .data(cars);
  // Appending 'li' dom-element for each 'car' data
  // `.text(car => to_str(car.make))` returns '"Honda"', '"..."'
  // `.text(car => car.make)` returns 'Honda', '...'
  // `.text(car => print_info(car))` "Car Accord of Honda in 2000 in $ 2800;..."
  bullet.enter()
      .append('li')
      .text(car => print_info(car))
      ;
}


// Set content of 'message' dom element
// `.textContent` should be set to a string format
// document.getElementById(
//   'content_header'
// ).textContent = `$ ${to_str(cars[0].price)}`;
  //to_str(cars);
  //JSON.stringify(JSON.parse(cars_str));//JSON.stringify(JSON.parse(cars_str)[0].year);


